/*  CALL BAL:                                                        */
/*                                                                   */
/*     Determines if the parentheses in a string are balanced.       */

arg  string .           /* the string to inspect                     */

if  balanced_parens(string) = 'Y' then   /* get answer from function */
    say 'Parentheses are balanced!'      /* write GOOD message ..or..*/
else
    say 'Parentheses are NOT balanced'   /* write INVALID message    */

exit 0


/*  BALANCED PARENS:                                                 */
/*                                                                   */
/*     Returns Y if parentheses in input string are balanced,        */
/*     N if the are not balanced.                                    */

balanced_parens:  

arg  string .           /* the string to inspect                     */

ctr = 0                 /* identifies right paren BEFORE a left one  */
valid = 1
endstring = length(string)             /* get length of input string */

do j=1  to endstring while (valid)
   char = substr(string,j,1)           /* inspect each character     */
   if char = '(' then ctr = ctr + 1
   if char = ')' then ctr = ctr - 1
   if ctr < 0   then valid = 0
end

if ctr = 0 then return 'Y'
           else return 'N'