/****************************************************************/
/* PHONE DIRECTORY UPDATE:                                      */
/*                                                              */
/*    Updates rows in the phone directory w/ new phone numbers. */
/****************************************************************/
signal on syntax                  /* capture SQL syntax errors  */
call sql_initialize               /* load all Rexx/SQL functions*/

if SQLConnect(,,,'mysql')    <> 0 then call sqlerr 'On connect'
if SQLCommand(u1,"use test") <> 0 then call sqlerr 'On use'
            
say "Enter name or 'EXIT':"       /* prompt for person for whom */
pull lname .                      /* we'll update the phone     */
 
do while (lname <> 'EXIT')

   /* retrieve the phone number for the person to update        */

   sqlstr = 'select phone from phonedir where lname ="' , 
      || lname || '"'
   if (SQLCommand(s1,sqlstr) <> 0) then call sqlerr 'On select'

   /* if we retrieved one row, we retrieved the person given    */
   /* go ahead and update that person's phone # in the database */

   if sqlca.rowcount <> 1 then
      say 'This person is not in the database:' lname
   else do
      say lname 'Current phone:' s1.phone.1 
      say 'Enter new phone number:'
      pull new_phone .
      sqlstr = 'update phonedir set phone ="' || new_phone || '"',
               || ' where lname ="' || lname || '"'
      if SQLCommand(u1,sqlstr) <> 0 then call sqlerr 'On update'
   end

   /* commit to end the interaction, get the next person's name */
   
   if SQLCommit() <> 0 then call sqlerr 'On commit'
   say "Enter name or 'EXIT':"
   pull lname .
end 

call sql_pgm_end                  /* disconnect, drop functions */
exit 0

/************ Script continues with subroutines *****************/

sql_pgm_end: procedure expose sqlca.
   
   if SQLDisconnect() <> 0 then call sqlerr 'On disconnect'

   if SQLDropFuncs('UNLOAD') <> 0 then
      say 'sqldropfuncs failed, rc: ' rc
  
   return

sql_initialize: procedure

   if RxFuncAdd('SQLLoadFuncs','rexxsql', 'SQLLoadFuncs') <> 0 then
      say 'rxfuncadd failed, rc: ' rc

   if SQLLoadFuncs() <> 0 then 
      say 'sqlloadfuncs failed, rc: ' rc

   return

sqlerr: procedure expose sqlca.
   parse arg msg
   say 'Program failed, message is: ' msg
   say sqlca.interrm                    /* write SQLCA messages */
   say 'SQL error is:' sqlca.sqlerrm    /* write SQLCA messages */
   call SQLDropFuncs 'UNLOAD'
   exit 99
   return 99

syntax: procedure                  /* capture any syntax errors */
   say 'Syntax error on line: ' sigl    /* identify syntax error*/
   return
