/* WHERE AM I:                                                   */
/*                                                               */
/*    This script learns about its environment and determines    */
/*    exactly which Windows or Linux OS it runs under.           */

parse version language level      date     month year .
parse source  system   invocation filename .

language = translate(language)       /* ensure using Regina Rexx */
if pos('REGINA',language) = 0 then
   say 'ERROR: Interpreter is not Regina:'  language

say 'Interpreter version/release date:' date month year
say 'Language standards level is:     ' level
say 'Version information from an OS command follows...'

/* determine operating system, get its version/release info      */

select  
   when system = 'WIN32' then
       'ver'
   when system = 'LINUX' then
       'uname -a'
   otherwise
      say 'Unexpected SYSTEM:' system
end

if rc <> 0 then            /* write message if OS command failed */
   say 'Bad return code on OS Version command:' rc
